/* $USAGI: mipv6_ha_ipsec.h,v 1.1.2.1 2003/08/09 06:22:22 takamiya Exp $ */
/*
 * Copyright (C)2001 USAGI/WIDE Project
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 *
 * Authors:
 *   Noriaki Takamiya <takamiya@linux-ipv6.org> / USAGI
 */
#include <linux/config.h>
#include <linux/sched.h>
#include <linux/notifier.h>
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/init.h>
#include <linux/types.h>
#include <linux/socket.h>
#include <linux/in6.h>
#include <linux/pfkeyv2.h> 
#include <net/spd.h>
#include <net/sadb.h>
#include <linux/list.h>
#include <linux/slab.h>
#include <linux/interrupt.h>
#include <asm/softirq.h>
#include <linux/spinlock.h>
#include <asm/uaccess.h>
 
#include "bul.h"
#include "bcache.h"

#define INET6_ADDRSTRLEN	46
/*
 * MIPV6_IPSEC_HA_OUT: ha->mn
 * MIPV6_IPSEC_HA_IN: mn->ha
 */
#define	MIPV6_IPSEC_HA_IN	0
#define	MIPV6_IPSEC_HA_OUT	1

int mipv6_change_sa_index_dst(struct sa_index *sa, struct in6_addr *coa, __u8 dir);
struct ipsec_sp  *mipv6_find_spd(struct in6_addr *dst, struct in6_addr *src,
	struct in6_addr *tunnel_dst, __u8 prefixlen_d, __u8 prefixlen_s, __u8 proto, __u8 mode, __u8 dir);
int __mipv6_mn_change_tunnel_ipsec_by_proto(struct mipv6_bul_entry *entry, __u8 proto);
int mipv6_mn_change_tunnel_ipsec(struct mipv6_bul_entry *entry);
int __mipv6_ha_change_tunnel_ipsec_by_proto(struct mipv6_bcache_entry *entry, __u8 proto);
int mipv6_ha_change_tunnel_ipsec(struct mipv6_bcache_entry *entry);
int __mipv6_ha_change_tunnel_ipsec_by_proto(struct mipv6_bcache_entry *entry, __u8 proto);
int mipv6_home_regist_with_esp(struct in6_addr *hoa, struct in6_addr *ha);
